/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2010 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: $
 * --------------------------------------------------------------------------
 */
package org.ow2.jonas.admin.autostart.business {

    import com.adobe.cairngorm.business.ServiceLocator;

import mx.controls.Alert;

import org.ow2.jasmine.kerneos.common.business.AbsDelegateResponder;
    import org.ow2.jonas.admin.autostart.vo.*;
    import mx.collections.ArrayCollection;

    public class BuilderDelegate extends AbsDelegateResponder
        implements IBuilderDelegate {

       ////////////////////////////////////////////////////////////////////
       //                                                                //
       //             Function that does the requested operation         //
       //                                                                //
       ////////////////////////////////////////////////////////////////////

        public function getJonasVersions() : void {
            var service : Object =
                ServiceLocator.getInstance().getRemoteObject("builderService");
            var call : Object = service.getJonasVersions();
            call.addResponder(this.responder);
        }

        public function getAvailableApplication() : void {
            var service : Object =
                ServiceLocator.getInstance().getRemoteObject("builderService");
            var call : Object = service.getAvailableApplication();
            call.addResponder(this.responder);
        }

        public function downloadFile(url : String) : void {
            var service : Object =
                ServiceLocator.getInstance().getRemoteObject("builderService");
            var call : Object = service.downloadFile(url);
            call.addResponder(this.responder);
        }

        public function startBuildProcess(builderVo : BuilderVO) : void {
            var service : Object =
                ServiceLocator.getInstance().getRemoteObject("builderService");
            var call : Object = service.startBuildProcess(builderVo);
            call.addResponder(this.responder);
        }

        public function getOutputContent() : void {
             var service : Object =
                ServiceLocator.getInstance().getRemoteObject("builderService");
            var call : Object = service.getOuputTextContent();
            call.addResponder(this.responder);
        }

        public function saveStarter(builderVo : BuilderVO) : void {
            var service : Object =
                ServiceLocator.getInstance().getRemoteObject("builderService");
            var call : Object = service.saveStarter(builderVo);
            call.addResponder(this.responder);
        }

        public function loadStarters() : void {
            var service : Object =
                ServiceLocator.getInstance().getRemoteObject("builderService");
            var call : Object = service.loadStarters();
            call.addResponder(this.responder);
        }

        public function loadStartersName() : void {
            var service : Object =
                ServiceLocator.getInstance().getRemoteObject("builderService");
            var call : Object = service.loadStartersName();
            call.addResponder(this.responder);
        }

        public function getJonasServices() : void {
            var service : Object =
                ServiceLocator.getInstance().getRemoteObject("builderService");
            var call : Object = service.getJonasServices();
            call.addResponder(this.responder);
        }

        public function getJonasFolders() : void {
            var service : Object =
                ServiceLocator.getInstance().getRemoteObject("builderService");
            var call : Object = service.getJonasFolders();
            call.addResponder(this.responder);
        }

        public function isValidUrl(url : String) : void {
            var service : Object =
                ServiceLocator.getInstance().getRemoteObject("builderService");
            var call : Object = service.isValidUrl(url);
            call.addResponder(this.responder);
        }

        public function setStartersPath(builderVo : BuilderVO) : void {
            var service : Object =
                ServiceLocator.getInstance().getRemoteObject("builderService");
            var call : Object = service.setStartersPath(builderVo);
            call.addResponder(this.responder);
        }

        public function deleteStarter(starterName : String) : void {
            var service : Object =
                ServiceLocator.getInstance().getRemoteObject("builderService");
            var call : Object = service.deleteStarter(starterName);
            call.addResponder(this.responder);
        }

        public function stopBuildProcess() : void {
            var service : Object =
                ServiceLocator.getInstance().getRemoteObject("builderService");
            var call : Object = service.stopBuildProcess();
            call.addResponder(this.responder);
        }

        public function saveFault(starterName:String):void {
            var service : Object =
                ServiceLocator.getInstance().getRemoteObject("builderService");
            var call : Object = service.saveFault(starterName);
            call.addResponder(this.responder);
        }
    }
}
