/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2010 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: ConfigurationVO.as 20254 2010-09-03 13:17:32Z skabore $
 * --------------------------------------------------------------------------
 */
package org.ow2.jonas.admin.autostart.view {


    import com.adobe.cairngorm.control.CairngormEventDispatcher;

import mx.controls.List;

import org.ow2.jonas.admin.autostart.event.*;
    import org.ow2.jonas.admin.autostart.model.*;
    import org.ow2.jonas.admin.autostart.vo.*;

    import mx.containers.VBox;
    import mx.collections.ArrayCollection;
    import mx.controls.Alert;
    import flash.net.FileReference;

import org.ow2.jonas.admin.autostart.vo.configuration.AdvancedJDBCConfigurationVO;
import org.ow2.jonas.admin.autostart.vo.configuration.JDBCConfigurationVO;


public class ConfigurationViewClass extends VBox {

        [Bindable]
        public var model : BuilderModelLocator = BuilderModelLocator.getInstance();

        [Bindable]
        public var selectedDatasource : Object;

        [Bindable]
        public var dbms : ArrayCollection = new ArrayCollection();

        [Bindable]
        public var jdbcDatasourceList : ArrayCollection = new ArrayCollection();

        [Bindable]
        public var advancedJdbcDatasourceList : ArrayCollection = new ArrayCollection();

        [Bindable]
        public var rarLink : ArrayCollection = new ArrayCollection();

        [Bindable]
        public var checkingLevel : ArrayCollection = new ArrayCollection();

        public function ConfigurationViewClass() {
        }

        /**
         * Initialize JOnAS services list.
         */
        public function init() : void {
            var builderVo : BuilderVO = new BuilderVO();
            var event : BuilderEvent = new BuilderEvent(BuilderEvent.EVENT_JONAS_SERVICES
                    + model.componentID);
            CairngormEventDispatcher.getInstance().dispatchEvent(event);
            dbms.addItem("--select an item--");
            dbms.addItem("PostgreSQL");
            dbms.addItem("Oracle");
            dbms.addItem("MySQL");
            dbms.addItem("FirebirdSQL");
            dbms.addItem("InterBase");
            dbms.addItem("Sybase");
            dbms.addItem("InstantDB");
            dbms.addItem("McKoi");
            dbms.addItem("DB2");
            dbms.addItem("HSQL");
            dbms.sort;

            rarLink.addItem("--select an item--");
            rarLink.addItem("JOnASJDBC_DM");
            rarLink.addItem("JOnASJDBC_DS");
            rarLink.addItem("JOnASJDBC_CP");
            rarLink.addItem("JOnASJDBC_XA");
            rarLink.sort;

            checkingLevel.addItem("--select an item--");
            checkingLevel.addItem("0");
            checkingLevel.addItem("1");
            checkingLevel.addItem("2");
            checkingLevel.addItem("3");
            checkingLevel.sort;
        }

        /**
         * Show the selected datasource details.
         * @param selectedItem the datasource.
         */
        public function showSelectedDatasourceDetails(selectedItem : Object) :void {
            selectedDatasource = selectedItem;
            /*for (var i:uint; i < model.builderVO.configuration.jdbcConfigurationVO.length; i++) {
                var datasource : JDBCConfigurationVO =
                        model.builderVO.configuration.jdbcConfigurationVO[i];
                if (datasource.datasourceName == selectedDatasource){
                    model.jdbcConfiguration = datasource;
                    model.jdbcConfiguration.advancedJDBCConfiguration =
                            datasource.advancedJDBCConfiguration;
                }
            }*/
        }

        /**
         * Add a datasource configuration to the list.
         * @param list the list component.
         */
        public function addDatasource(list : List) : void {
            var dsName : String = model.jdbcConfiguration.datasourceName;
            if (dsName.length != 0) {
               if (!jdbcDatasourceList.contains(dsName)) {
                   jdbcDatasourceList.addItem(dsName);
                   var datasource : JDBCConfigurationVO = model.jdbcConfiguration;
                   //model.builderVO.configuration.jdbcConfigurationVO.addItem(datasource);
               }
               model.jdbcConfiguration = new JDBCConfigurationVO();
            } else {
                Alert.show("Please, set the form correctly !", "Information dialog");
            }
            advancedJdbcDatasourceList = jdbcDatasourceList;
            list.selectedItem = null;
        }

        /**
         * Add a datasource configuration to the list.
         * @param list the list component.
         */
        public function deleteDatasource(list : List) : void {
            /*for (var i:uint; i < model.builderVO.configuration.jdbcConfigurationVO.length; i++) {
                var datasource : JDBCConfigurationVO =
                        model.builderVO.configuration.jdbcConfigurationVO[i];
                if (datasource.datasourceName == selectedDatasource){
                    jdbcDatasourceList.removeItemAt(i);
                    model.builderVO.configuration.jdbcConfigurationVO.removeItemAt(i);
                    model.jdbcConfiguration = new JDBCConfigurationVO();
                }
            }*/
            advancedJdbcDatasourceList = jdbcDatasourceList;
            list.selectedItem = null;
        }
    
        /**
         * Add a datasource configuration to the list.
         * @param list the list component.
         */
        public function resetDatasourceField(list : List) : void {
            model.jdbcConfiguration = new JDBCConfigurationVO();
            list.selectedItem = null;
        }

        /**
         * Save the selected datasource advanced parameters.
         * @param list the list component.
         */
        public function saveAdvancedJdbcConig(list : List) :void {
            /*for (var i:uint; i < model.builderVO.configuration.jdbcConfigurationVO.length; i++) {
                var datasource : JDBCConfigurationVO =
                        model.builderVO.configuration.jdbcConfigurationVO[i];
                if (datasource.datasourceName == selectedDatasource){
                    datasource.advancedJDBCConfiguration =
                            model.jdbcConfiguration.advancedJDBCConfiguration;
                }
            }*/
            list.selectedItem = null;
        }

        /**
         * Show the selected datasource advanced details.
         * @param selectedItem the datasource.
         */
        public function showSelectedDatasourceAdvancedDetails(selectedItem : Object) :void {
            selectedDatasource = selectedItem;
            /*for (var i:uint; i < model.builderVO.configuration.jdbcConfigurationVO.length; i++) {
                var datasource : JDBCConfigurationVO =
                        model.builderVO.configuration.jdbcConfigurationVO[i];
                if (datasource.datasourceName == selectedDatasource){
                    model.jdbcConfiguration.advancedJDBCConfiguration =
                            datasource.advancedJDBCConfiguration;
                }
            }*/
        }

        /**
         * Reset datasource advanced field configuration to the list.
         * @param list the list component.
         */
        public function resetDatasourceAdvancedField(list : List) :void {
            /*for (var i:uint; i < model.builderVO.configuration.jdbcConfigurationVO.length; i++) {
                var datasource : JDBCConfigurationVO =
                        model.builderVO.configuration.jdbcConfigurationVO[i];
                if (datasource.datasourceName == list.selectedItem){
                    model.jdbcConfiguration.advancedJDBCConfiguration = new AdvancedJDBCConfigurationVO();
                }
            }*/
        }
    }
}
